config/routes.rb
Rails.application.routes.draw do
  devise_for :users

  root to: 'activities#index'
  get '/activities', to: redirect('/')
  resources :actors, only: [:index, :show] do
    collection do
      get :lookup, to: 'actors#lookup'
    end
    resources :activities, only: [:index]
  end
  get :feed, to: 'activities#feed'
  resources :followings, only: [:create, :destroy] do
    collection do
      post :follow, to: 'followings#follow'
    end

    member do
      put :accept, to: 'followings#accept'
    end
  end
  resources :notes
  resources :users, except: [:new, :create, :destroy]

  get '/.well-known/webfinger', to: 'web_finger#find', as: :webfinger
  get '/.well-known/host-meta', to: 'web_finger#host_meta', as: :host_meta
  get '/.well-known/nodeinfo', to: 'web_finger#node_info', as: :node_info
  get '/nodeinfo/2.0', to: 'web_finger#show_node_info', as: :show_node_info

  namespace :federation do
    resources :actors, only: [:show] do
      member do
        get :followers
        get :following
      end
      get :outbox, to: 'activities#outbox'
      post :inbox, to: 'activities#create'
      resources :activities, only: [:show]
      resources :followings, only: [:show]
      resources :notes, only: [:show]
    end
  end
end

app/views/layouts/_flash_messages.html.haml
- unless flash.empty?
  .flash-messages
    - flash.each do |name, message|
      %div{ class: "alert alert--#{name}" }= message

app/views/layouts/application.html.haml
!!!
%html
  %head
    %meta{ :content => 'text/html; charset=UTF-8', 'http-equiv' => 'Content-Type' }/
    %title Co
    = csrf_meta_tags
    = csp_meta_tag
    = stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload'
    = javascript_pack_tag 'application', 'data-turbolinks-track': 'reload'
    :javascript
      I18n.locale = '#{I18n.locale}'
  %body
    %nav
      = link_to 'Home', root_path
      = link_to 'Notes', notes_path
      = link_to 'Users', users_path
      = link_to 'Actors', actors_path
      - if current_user
        = link_to 'Feed', feed_path
        = link_to 'You', actor_path(current_user.actor)
        = link_to 'Logout', destroy_user_session_path, method: :delete
      - else
        = link_to 'Sign in', new_user_session_path

    %hr
    = render 'actors/lookup_form'
    %hr

    = render 'layouts/flash_messages'
    = yield